'------------------------------------------------------------------------
'  JetStreamUsage.vbs (v2.1)
'------------------------------------------------------------------------
'
' Retreives the local, international and total traffic usage for an
' Xtra Jetstream account.
'
' This script is the bastard child of the ParadiseBroadband.vbs script by
' NeM and the JetstreamUsage.vbs script by Ba'alzaman.
'
' NOTES:- Set your login, password and quota below for this script to 
'	work correctly.
'
' 	- Execute the "updateUsage" function to update your Jetsream
' 	usage. Ignore any warnings from antivirus software that this 
'	is a malicious script (it just writes a small .tmp file to your
'	Configs directory to save bandwidth)
'
'	- The "updateUsage" function should only be run every 120 min in
'	Samurize; Jetstream only update your stats every 120 min and it
'	is a waste of bandwidth checking the usage every say 5min! Set
'	the other functions to update more often (say every 5 min) to
' 	ensure the usage is kept up-to-date.
'
'	- The "usageByTempFile" function writes a bunch of stats to a
'	file "JetstreamUsage.txt" in your Samurize directory. Monitor
'	this file with a Text File meter in Samurize if you prefer
'	(usually makes the script run a lot smoother)
'
' Special Thanks to:
'
' Ba'alzaman	- for various chunks of code from his Jetstream script.
'
' Changes in v2.1:
' -----------------
' - tweaked functions to be independent of system date format
'
' Changes in v2.01:
' -----------------
' - fixed strange/rare traffic total bug (thanks stefan00 for testing)
'
'								-NeM
'------------------------------------------------------------------------

'========================================================================
' ENTER YOUR ACCOUNT DETAILS HERE:
' --------------------------------

JSADSL_login = "xx"	'this is your phone number with area code without the leading 0 (zero)
JSADSL_password = "xx"	'this is your phone account number (normally a 9 digit number)

MONTHLY_QUOTA = 10240	' How many megabytes of data you get per billing period eg. 10GB = 10240MB

'========================================================================





' =============================================================
' PREFERENCES
' ===========
'
' Please choose the style you want the date to appear as.
' (NOTE: this is for the formattedDate functions only)
'
' eg. for the 21st of Febuary 2003:
' (1) 21 Feb
' (2) 21 Feb 03
' (3) 21/02
' (4) 21/02/03

DATE_STYLE = 2
' =============================================================

' =============================================================
' How many decimal places you want the per-day stats rounded to

PRECISION = 2
' =============================================================

' =============================================================
' Where you want the (optional) text file placed
TMP_FILE3 = "C:\Program Files\Samurize\JetstreamUsage.txt"
' =============================================================


'DO NOT CHANGE THE FOLLOWING DEFINITIONS:
'#######################################################
Dim fso, JSADSL_Domain, feedname, feedname2, logoffurl, OfflineMsg, objRS, JSADSL_login, JSADSL_password, savePath,TMP_FILE,TMP_FILE2

JSADSL_Domain = "https://jetstream-usage.telecom.co.nz/cgi-bin/iaf/iafUserMaint?IAF_SERVER_SERVICE=iafserver&IAF_SERVER=se259&HGE_LOCALE=hgeTemplates/csc/&formEvent=maintain&formName=cscUserMaint.html&formError=SCLMessageBase.html&SCLValidationMessage=cscErrorPassword.html&IAF_userID=" & JSADSL_login & "&IAF_customerNumber=&IAF_LogonType=USER&IAF_LogonUserID=" & JSADSL_login & "&IAF_LogonPassword=" & JSADSL_password & "&enterbutton=Enter"
logoffurl = "https://jetstream-usage.telecom.co.nz/cgi-bin/iaf/iafDisplay?formEvent=logoff&formName=Logon.html"
feedname = "Jetstream Usage page"
feedname2 = "logged in"
OfflineMsg = "Offline OR remote site unreachable."
set fso=CreateObject("Scripting.FileSystemObject")
savePath = fso.GetSpecialFolder(2) & "\jetstream\" 
TMP_FILE = feedname & ".tmp"
TMP_FILE2 = feedname2 & ".tmp"

if not fso.FolderExists(savePath) then
    fso.CreateFolder(savePath)
End if
'#######################################################


' === FUNCTIONS CALLED BY SAMURIZE ===

Function usageByTempFile()
    usageByTempFile = updateUsage()
    usage = getTotalTraffic() & vbCrLf & getPercentTraffic() & vbCrlf & getTrafficRemaining() & vbCrlf & getPeriodStartDate & vbCrlf & formattedStartDate() & vbCrlf & getPeriodEndDate & vbCrlf & formattedEndDate() & vbCrLf & getUsageUsedPerDay() & vbCrlf & getUsageLeftPerDay() 
    WriteFile TMP_FILE3,usage
End Function

Function getTotalTraffic()
    getTotalTraffic = getTraffic()
End Function

Function getPercentTraffic()
    getPercentTraffic = getTotalTraffic() / MONTHLY_QUOTA * 100
End Function

Function getTrafficRemaining()
    stringTraffic = getTraffic()
    getTrafficRemaining =  MONTHLY_QUOTA - CDbl(stringTraffic)
End Function

Function getPeriodStartDate()
    getPeriodStartDate = GetPeriodDate(0)
End Function

Function getPeriodEndDate()
    getPeriodEndDate = GetPeriodDate(1)
End Function

Function formattedEndDate()
    formattedEndDate = CustomFormatDate(getPeriodEndDate())
End Function

Function formattedStartDate()
    formattedStartDate = CustomFormatDate(getPeriodStartDate())
End Function

Function getDaysLeft()
    currentDate = Date()
    periodEnd = getPeriodEndDate()
    peMonth = CInt(MonthNameToNum(mid(periodEnd, 4, 3)))
    peDay = CInt(mid(periodEnd, 1, 2))
    currentMonth = Month(currentDate)
    currentDay = Day(currentDate)
    If currentMonth = peMonth Then
	' Same month
	daysLeft = peDay - currentDay + 1
    Else
	'different months
	daysLeft = peDay + numDaysInMonth(currentMonth) - currentDay + 1
    End If
    getDaysLeft = daysLeft
End Function

Function getUsageLeftPerDay()
    currentDate = Date()
    periodEnd = getPeriodEndDate()
    peMonth = CInt(MonthNameToNum(mid(periodEnd, 4, 3)))
    peDay = CInt(mid(periodEnd, 1, 2))
    currentMonth = Month(currentDate)
    currentDay = Day(currentDate)
    If currentMonth = peMonth Then
	    ' Same month
	    daysLeft = peDay - currentDay + 1
    Else
	    'different months
	    daysLeft = peDay + numDaysInMonth(currentMonth) - currentDay + 1
    End If
    If daysLeft = 0 Then
	    getUsageLeftPerDay = "-"
    Else
	    getUsageLeftPerDay = round((getTrafficRemaining() / daysLeft), PRECISION)
    End If
End Function


Function getUsageUsedPerDay()
    currentDate = Date()
    periodEnd = getPeriodEndDate()
    peMonth = CInt(MonthNameToNum(mid(periodEnd, 4, 3)))
    peDay = CInt(mid(periodEnd, 1, 2))
    currentMonth = Month(currentDate)
    currentDay = Day(currentDate)
    If currentMonth = peMonth Then
	    ' Same month
	    daysUsed = 28 - (peDay - currentDay)
    Else
	    'different months
	    daysUsed = 28 - (peDay + numDaysInMonth(currentMonth) - currentDay)
    End If
    If daysUsed < 1 Then
	    daysUsed = 1
    End If
    getUsageUsedPerDay = round((getTotalTraffic() / daysUsed), PRECISION)
End Function

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Modified version of Ba'alzaman's original GetJetstreamUsageFromWeb() function
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function UpdateUsage()
    dim xml,xml2,fs,f,fs2,xmlhttp,userID,jetstreamusageurl,JSADSL_customernumber

    set fs=CreateObject("Scripting.FileSystemObject")
    if not fs.fileexists(savePath & TMP_FILE) then
	set xmlhttp = Createobject("MSXML2.ServerXMLHTTP")
	xmlhttp.Open "GET",JSADSL_Domain,false
	xmlhttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded" ' POST Data
	xmlhttp.setrequestheader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
	xmlhttp.send
	userID = BinToText(xmlhttp.responsebody, 35000)
	WriteFile savePath & TMP_FILE2, userID 
	JSADSL_customernumber = getValueFromFile2("<INPUT TYPE=HIDDEN NAME=IAF_customerNumber VALUE=",">")
	jetstreamusageurl = "https://jetstream-usage.telecom.co.nz/cgi-bin/iaf/iafReports?formEvent=generate&formName=cscUserUsageBasic.html&fromForm=none&nextCgi=x&nextTemplate=x&nextEvent=x&IAF_type=csc_usage.sh&IAF_usePrinter=S&IAF_printerName=&IAF_startAccount=0&IAF_endAccount=0&IAF_rangeType=O&domain=null&IAF_customerNumber=" & JSADSL_customernumber & "&IAF_userID=" & JSADSL_login & ""
	xmlhttp.Open "GET",jetstreamusageurl,false
	xmlhttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded" ' POST Data
	xmlhttp.setrequestheader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
	xmlhttp.send 
	xml = BinToText(xmlhttp.responsebody, 35000)
	WriteFile savePath & TMP_FILE, xml 
	xmlhttp.Open "GET",logoffurl,false
	xmlhttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded" ' POST Data
	xmlhttp.setrequestheader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
	xmlhttp.send 

    end if

    set xmlhttp = Createobject("MSXML2.ServerXMLHTTP")
    xmlhttp.Open "GET",JSADSL_Domain,false
    xmlhttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded" ' POST Data
    xmlhttp.setrequestheader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
    xmlhttp.send
    userID = BinToText(xmlhttp.responsebody, 35000)
    WriteFile savePath & TMP_FILE2, userID 
    JSADSL_customernumber = getValueFromFile2("<INPUT TYPE=HIDDEN NAME=IAF_customerNumber VALUE=",">")
    jetstreamusageurl = "https://jetstream-usage.telecom.co.nz/cgi-bin/iaf/iafReports?formEvent=generate&formName=cscUserUsageBasic.html&fromForm=none&nextCgi=x&nextTemplate=x&nextEvent=x&IAF_type=csc_usage.sh&IAF_usePrinter=S&IAF_printerName=&IAF_startAccount=0&IAF_endAccount=0&IAF_rangeType=O&domain=null&IAF_customerNumber=" & JSADSL_customernumber & "&IAF_userID=" & JSADSL_login & ""
    xmlhttp.Open "GET",jetstreamusageurl,false
    xmlhttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded" ' POST Data
    xmlhttp.setrequestheader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
    xmlhttp.send 
    xml = BinToText(xmlhttp.responsebody, 35000)
    WriteFile savePath & TMP_FILE, xml 
    xmlhttp.Open "GET",logoffurl,false
    xmlhttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded" ' POST Data
    xmlhttp.setrequestheader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
    xmlhttp.send 

    '"<TD COLSPAN=2>This Meter reflects your usage up to ","</TD></TR>")
    UpdateUsage = "Last updated at " & getValueFromText3("<TD COLSPAN=2>This Meter reflects your usage up to ", "</TD></TR>", ReadFile(savepath&TMP_FILE))
    UpdateUsage = replace(updateusage, vblf," ")
End Function   








' === END OF FUNCTIONS CALLED BY SAMURIZE ===


Private Function getTraffic()
    dim strAllInfo
    strAllInfo = readFile(SavePath & TMP_FILE)
    
    checkFile = InStr(strAllInfo, "Customer Self Care")
    If checkFile > 0 Then
    
	    Set regEx = New RegExp
	    regEx.Pattern = "RIGHT NOWRAP>\s*([\d.]*)\s*MB</TD></TR>"
	    Set Matches = regEx.Execute(Trim(strAllInfo))
	    getTraffic = trim(Matches(0).submatches(0))
	    Set regEx = nothing

    Else
	    getTraffic = "error"
    End If
End Function


Private Function GetPeriodDate(num)
    Dim strAllInfo

    strAllInfo = readFile(savePath & TMP_FILE)
    
    checkFile = InStr(strAllInfo, "Customer Self Care")

    If checkFile > 0 Then

	Set regEx = New RegExp 
	regEx.Pattern = "<H2>\d* - Usage for .*?-.*?</H2>"
	Set Matches = regEx.Execute(Trim(strAllInfo))
	getPeriodDate = Matches(0)
	
	' <H2>33417272 - Usage for 18 Mar 2004 - 17 Apr 2004</H2>
	regEx.Pattern = "\d{1,2} \w* \d{4}"
	regEx.Global = True
	
	Set Matches = regEx.Execute(Trim(getPeriodDate))
	getPeriodDate = Matches(num)
	
	Set regEx = nothing

    Else
	    getPeriodDate = "error"
    End If
End Function


Private Function CustomFormatDate(style)

    If DATE_STYLE > 2 Then
	dateString = mid(style, 1, 2) & "/" & MonthNameToNum(mid(style, 4, 3))
	If DATE_STYLE = 4 Then
	    dateString = dateString & "/" & mid(style, 10, 2)
	End If
    End If

    If DATE_STYLE < 3 Then
	dateString = mid(style, 1, 2) & " " & mid(style, 4, 3)
	If DATE_STYLE = 2 Then
	    dateString = dateString & " " & mid(style, 10 ,2)
	End If
    End If
    CustomFormatDate = dateString
End Function


Private Function numDaysInMonth(monthNo)

    currentYear = Year(Date())
    Select Case monthNo
	Case 1
		numDaysInMonth = 31 ' Jan
	Case 2
		If (currentYear/4 - Int(currentYear/4)) = 0 Then
		    ' Leap year
		    numDaysInMonth = 29
		Else 
		    ' non-leap year
		    numDaysInMonth = 28
		End If
	Case 3
		numDaysInMonth = 31 ' Mar
	Case 4
		numDaysInMonth = 30 ' Apr
	Case 5
		numDaysInMonth = 31 ' May
	Case 6
		numDaysInMonth = 30 ' Jun
	Case 7
		numDaysInMonth = 31 ' Jul
	Case 8
		numDaysInMonth = 31 ' Aug
	Case 9
		numDaysInMonth = 30 ' Sept
	Case 10
		numDaysInMonth = 31 ' Oct
	Case 11
		numDaysInMonth = 30 ' Nov
	Case 12
		numDaysInMonth = 31 ' Dec
    End Select
End Function


Private Function monthnametonum(num)
    Select Case num
    Case "Jan"
	    monthnametonum = 1
    Case "Feb"
	    monthnametonum = 2
    Case "Mar"
	    monthnametonum = 3
    Case "Apr"
	    monthnametonum = 4
    Case "May"
	    monthnametonum = 5
    Case "Jun"
	    monthnametonum = 6
    Case "Jul"
	    monthnametonum = 7
    Case "Aug"
	    monthnametonum = 8
    Case "Sep"
	    monthnametonum = 9
    Case "Oct"
	    monthnametonum = 10
    Case "Nov"
	    monthnametonum = 11
    Case "Dec"
	    monthnametonum = 12
    End Select
End Function


' ========================================================================
'  ALL OF THE FOLLOWING FUNCTIONS WERE TAKEN FROM THE ORIGINAL JETSTREAM
'                       USAGE SCRIPT BY BA'ALZAMAN
' ========================================================================


' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'        Function to convert binary data to text
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Function BinToText(varBinData, intDataSizeInBytes)    ' as String
    Const adFldLong = &H00000080
    Const adVarChar = 200
    Set objRS = CreateObject("ADODB.Recordset")

    objRS.Fields.Append "txt", adVarChar, intDataSizeInBytes, adFldLong
    objRS.Open

    objRS.AddNew
    objRS.Fields("txt").AppendChunk varBinData
    BinToText = objRS("txt").Value

    objRS.Close
    Set objRS = Nothing
End Function

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' this function reads a file and returns its content as text.
' it takes one argument which is the complete file path.
' returns 0 if file doesnt exist.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Function ReadFile(file)
    dim fs,f,data
    set fs=CreateObject("Scripting.FileSystemObject")
    if fs.fileexists(file) then
	    set f=fs.OpenTextFile(file,1)
	    data = f.readall
	    f.close
    else
	    data = -1
    end if
    set f=nothing
    set fs=nothing
    ReadFile = data
End Function

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' This function writes content to a text file.
' it takes two arguments the complete file path and the content to write.
' note that it overwrites the file everytime.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Sub WriteFile(file, content)
    dim fs,f
    set fs=CreateObject("Scripting.FileSystemObject")
    set f=fs.CreateTextFile(file,true)
    f.write(content)
    f.close
    set f=nothing
    set fs=nothing
End Sub



' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'        Function for extracting the usage data
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Function getValueFromFile2(startStr, endStr)
    Dim text, file_obj, file, filePath, fileSystemObject, result
    
    Set fso = CreateObject ("Scripting.FileSystemObject")
    If (fso.FileExists(savePath & TMP_FILE2)) Then
	Set filePath = fso.GetFile(savePath & TMP_FILE2) ' Creates the connection to the file
	set file = filePath.OpenAsTextStream (1, -2) ' Opens the file for reading
	
	'Read the file line by line
	result = "Data Not Found"
	
	text = file.ReadAll
	 
	file.Close ' Closes the file
	Set filePath = nothing ' Resets variable
	Set fileSystemObject = nothing ' Resets variable
	
	getValueFromFile2 = getValueFromText2(startStr, endStr, text)
    Else
      getValueFromFile2 = "Data Not Found"
    End If
End Function

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'        Another function for finding in the data what we want
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Function getValueFromText2(startStr, endStr, text)
    Dim regEx, matches, match, startStrPos, endStrPos, result
    
    startStrPos = InStr(text, startStr)    
    
    If (startStrPos > 0) Then
	startStrPos = startStrPos + Len(startStr)
	endStrPos = InStr(startStrPos, text, endStr)
	result = endStrPos 
	text = Mid(text, startStrPos, (endStrPos - startStrPos))
	result = text
	Set regEx = New RegExp 
	regEx.Pattern = "[\w]{1,}.[\w]{1,}"
	Set Matches = regEx.Execute(Trim(text))
	For Each Match in Matches   ' Iterate Matches collection.
	    getValueFromText2 = Match.Value
	Next
    Else
	getValueFromText2 = "N/A"    
    End If
End Function



' quick hack to show when the stats were last updated by Xtra
Private Function getValueFromText3(startStr, endStr, text)
    Dim regEx, matches, match, startStrPos, endStrPos, result
    startStrPos = InStr(text, startStr)    
    '<TD COLSPAN=2>This Meter reflects your usage up to 19:26:24\non 01/04/2004</TD></TR>
    If (startStrPos > 0) Then
	startStrPos = startStrPos + Len(startStr)
	endStrPos = InStr(startStrPos, text, endStr)
	result = endStrPos 
	text = Mid(text, startStrPos, (endStrPos - startStrPos))
	result = text
	Set regEx = New RegExp 
	regEx.Pattern = "(\d|:)*\non (\d|/)*"
	Set Matches = regEx.Execute(Trim(text))
	For Each Match in Matches   ' Iterate Matches collection.
	    getValueFromText3 = Match.Value
	Next
    Else
	getValueFromText3 = "N/A"    
    End If
End Function


